package RanieriApp;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.text.ParseException;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Vector;

import Utilities.Commons;



/**
 * @author Michele Ranieri
 * @modifiche Graziella Cipolletti
 */
public class A2 extends Commons{

	public void eseguiA2() throws IOException {

		//Crea 'partizioni' come insieme di vettori, uno per ogni coppia di frasi
		//Ogni vettore conterr tutte le decisioni che si riferiscono alla stessa coppia di frasi 
		Hashtable<String,Vector<Decisione>> partizioni=new Hashtable<String,Vector<Decisione>>();
		
		//Prende come file di input tutti quelli contenuti nella directory Base
		/* 
		 * Ranieri
		 * 		File[] baseFiles=new File("Base").listFiles();
		 *      for(int i=0;i<baseFiles.length;i++){
		 *      Decisione.parseFile(baseFiles[i],partizioni);
		 *      }
			*/
		/*
		 * Cipolletti
		 * 
		 */
		Commons.matrDecisions=null;
		Commons.matrDecisions=new HashMap<String, Vector<String>>();
		
		Commons.filterNomeContenuto();
		
		File[] baseFiles=new File[Commons.fV.size()];
		for(int y=0;y<Commons.fV.size();y++)baseFiles[y]=Commons.fV.elementAt(y);
		

		
		
		for(int i=0;i<baseFiles.length;i++){
			boolean check=Decisione.parseFile(baseFiles[i],partizioni);
			if(!check)
			{
				System.out.println(baseFiles[i].getAbsolutePath()+" NO RANDOM SORT");
			}
			
		}
		
		
		
		//usa come file di riferimento il file FM generato dall'applicazione A1
		/*
		 * Ranieri
		 * creaFileN (partizioni,  "FMF.txt", "FN.txt" );
          */
		
		/*
		 * Cipolletti
		 * 
		 */
		creaFileN (partizioni,  Commons.FREF.getAbsolutePath(), Commons.N.getAbsolutePath() );
	}


	//Crea il file N con tutte le decisioni di input confrontate con il file di riferimento
	public static void creaFileN(Hashtable<String,Vector<Decisione>> partizioni, String fileRef,String fileN)throws IOException{
		
		//legge il file FRef
		Hashtable<String,Vector<Decisione>> decisioniRif=new Hashtable<String,Vector<Decisione>>();
		Decisione.parseFile(new File(fileRef), decisioniRif);
		
		PrintStream N = new PrintStream (new FileOutputStream (new File (fileN)));
		
		Enumeration<Vector<Decisione>> e = partizioni.elements() ;
		while(e.hasMoreElements()){ //per ogni classe di equivalenza
			Vector<Decisione> v = e.nextElement();
			Enumeration<Decisione>e2=v.elements();
			Decisione d=null;
			while(e2.hasMoreElements()){ //per ogni decisione
				d=e2.nextElement();
				
				Vector<Decisione> decRif=decisioniRif.get(d.getKey());
				if (decRif!=null){ //se esiste una corrispondente decisione di riferimento
					
					String campoDecision=d.getDecision(), newCampoDecision="";
					String campoDecisionRef=decRif.get(0).getDecision();
					
					//confronta i due campi decision
					
					if(campoDecision.equalsIgnoreCase(campoDecisionRef)){
						if(campoDecisionRef.equalsIgnoreCase("Coincide")){
							newCampoDecision="VP";
						}else if(campoDecisionRef.equalsIgnoreCase("Unrelated")){
							newCampoDecision="VN";
						}
					}else{ //se i campi sono diversi
						if(campoDecisionRef.equalsIgnoreCase("Coincide")){
							newCampoDecision="FN";
						}else if(campoDecisionRef.equalsIgnoreCase("Unrelated")){
							newCampoDecision="FP";
						}
					}
					
					d.setDecision(newCampoDecision);
					N.println(d.toString());
				}
					
			}
							
		}
		
		N.close();
		System.out.println("Creato il file "+fileN);

	}

	

}
