package Utilities;


/**
 * Exception thrown by SWTLoader.
 * 
 * @author Silvio Moioli
 */
public class LoadingException extends Exception {

	/**
	 * Default constructor.
	 * 
	 * @see java.lang.Exception#Exception()
	 */
	public LoadingException() {
		super();
	}

	/**
	 * @see java.lang.Exception#Exception()
	 */
	public LoadingException(String message) {
		super(message);
	}

	/**
	 * @see java.lang.Exception#Exception()
	 */
	public LoadingException(Throwable cause) {
		super(cause);
	}

	/**
	 * @see java.lang.Exception#Exception()
	 */
	public LoadingException(String message, Throwable cause) {
		super(message, cause);
	}
}
